﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Default.aspx.cs" Inherits="Default" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <telerik:RadStyleSheetManager ID="RadStyleSheetManager1" runat="server" />
</head>
<body>
    <form id="form1" runat="server">
        <telerik:RadScriptManager ID="RadScriptManager1" runat="server">
            <Scripts>
                <asp:ScriptReference Assembly="Telerik.Web.UI" Name="Telerik.Web.UI.Common.Core.js" />
                <asp:ScriptReference Assembly="Telerik.Web.UI" Name="Telerik.Web.UI.Common.jQuery.js" />
                <asp:ScriptReference Assembly="Telerik.Web.UI" Name="Telerik.Web.UI.Common.jQueryInclude.js" />
            </Scripts>
        </telerik:RadScriptManager>
        <telerik:RadScriptBlock ID="RadScriptBlock1" runat="server">
            <script type="text/javascript">
                //Put your JavaScript code here.
                var selected = {};
                function masterTableCreating(sender, args) {
                    var value = $get("<%= HiddenField1.ClientID %>").value;

                    if (value != "") {
                        selected = JSON.parse(value);
                    }
                }
                function saveSelection() {
                    $get("<%= HiddenField1.ClientID %>").value = JSON.stringify(selected);
                };
                function onRowSelected(sender, args) {
                    var orderID = args.getDataKeyValue("OrderID");
                    if (!selected[orderID]) {
                        selected[orderID] = true;
                    }
                    saveSelection();
                }
                function onRowDeselected(sender, args) {
                    var orderID = args.getDataKeyValue("OrderID");
                    if (selected[orderID]) {
                        delete selected[orderID];
                    }
                    saveSelection();
                }
                function onRowCreated(sender, args) {
                    var orderID = args.getDataKeyValue("OrderID");
                    if (selected[orderID]) {
                        args.get_gridDataItem().set_selected(true);
                    }
                }
                function gridCreated(sender, eventArgs) {
                    var masterTable = sender.get_masterTableView(),
                            headerCheckBox = $telerik.$(masterTable.HeaderRow).find(":checkbox")[0];

                    if (headerCheckBox) {
                        headerCheckBox.checked = masterTable.get_selectedItems().length
                                == masterTable.get_dataItems().length;
                    }
                }
            </script>
        </telerik:RadScriptBlock>
        <telerik:RadAjaxManager ID="RadAjaxManager1" runat="server">
            <AjaxSettings>
                <telerik:AjaxSetting AjaxControlID="RadGrid1">
                    <UpdatedControls>
                        <telerik:AjaxUpdatedControl ControlID="RadGrid1" />
                    </UpdatedControls>
                </telerik:AjaxSetting>
                <telerik:AjaxSetting AjaxControlID="RadButton1">
                    <UpdatedControls>
                        <telerik:AjaxUpdatedControl ControlID="RadGrid1" />
                        <telerik:AjaxUpdatedControl ControlID="Label1" />
                    </UpdatedControls>
                </telerik:AjaxSetting>
                <telerik:AjaxSetting AjaxControlID="RadButton2">
                    <UpdatedControls>
                        <telerik:AjaxUpdatedControl ControlID="RadGrid1" />
                        <telerik:AjaxUpdatedControl ControlID="HiddenField1" />
                    </UpdatedControls>
                </telerik:AjaxSetting>
            </AjaxSettings>
        </telerik:RadAjaxManager>
        <telerik:RadGrid ID="RadGrid1" runat="server" AllowPaging="True" CellSpacing="0"
            AllowMultiRowSelection="true" GridLines="None" OnNeedDataSource="RadGrid1_NeedDataSource"
            Width="800px" AllowFilteringByColumn="True" AllowSorting="True">
            <ClientSettings>
                <Selecting AllowRowSelect="True" />
                <ClientEvents OnRowCreated="onRowCreated" OnRowSelected="onRowSelected" OnRowDeselected="onRowDeselected"
                    OnGridCreated="gridCreated" OnGridCreating="masterTableCreating" />
            </ClientSettings>
            <MasterTableView AutoGenerateColumns="False" DataKeyNames="OrderID"
                ClientDataKeyNames="OrderID">
                <Columns>
                    <telerik:GridClientSelectColumn UniqueName="SelectColumn">
                    </telerik:GridClientSelectColumn>
                    <telerik:GridBoundColumn DataField="OrderID" DataType="System.Int32" FilterControlAltText="Filter OrderID column"
                        HeaderText="OrderID" ReadOnly="True" SortExpression="OrderID" UniqueName="OrderID">
                    </telerik:GridBoundColumn>
                    <telerik:GridDateTimeColumn DataField="OrderDate" DataType="System.DateTime" FilterControlAltText="Filter OrderDate column"
                        HeaderText="OrderDate" SortExpression="OrderDate" UniqueName="OrderDate">
                    </telerik:GridDateTimeColumn>
                    <telerik:GridNumericColumn DataField="Freight" DataType="System.Decimal" FilterControlAltText="Filter Freight column"
                        HeaderText="Freight" SortExpression="Freight" UniqueName="Freight">
                    </telerik:GridNumericColumn>
                    <telerik:GridBoundColumn DataField="ShipName" FilterControlAltText="Filter ShipName column"
                        HeaderText="ShipName" SortExpression="ShipName" UniqueName="ShipName">
                    </telerik:GridBoundColumn>
                    <telerik:GridBoundColumn DataField="ShipCountry" FilterControlAltText="Filter ShipCountry column"
                        HeaderText="ShipCountry" SortExpression="ShipCountry" UniqueName="ShipCountry">
                    </telerik:GridBoundColumn>
                </Columns>
            </MasterTableView>
        </telerik:RadGrid>
        <asp:SqlDataSource ID="SqlDataSource1" runat="server" ConnectionString="<%$ ConnectionStrings:ConnectionString %>"
            SelectCommand="SELECT [OrderID], [OrderDate], [Freight], [ShipName], [ShipCountry] FROM [Orders]"></asp:SqlDataSource>
        <br />
        <telerik:RadButton ID="RadButton1" runat="server" Text="Show Selected"
            OnClick="RadButton1_Click" AutoPostBack="true" />
        <telerik:RadButton ID="RadButton2" runat="server" Text="Select All Records"
            AutoPostBack="true" OnClick="RadButton2_Click" />
        <br />
        <br />
        <asp:HiddenField ID="HiddenField1" runat="server" Value="" />
        <asp:Label ID="Label1" runat="server" Text=""></asp:Label>
    </form>
</body>
</html>
